// FlashManGBxDlg.cpp : t@C
//

#include "stdafx.h"
#include "FlashManGBx.h"
#include "FlashManGBxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// c[qg\_CAOEACe ID Q
const UINT CFlashManGBxDlg::m_iToolTipItems[] = {
	IDOK,
	IDCANCEL,
	IDC_LIST_ROM,
	IDC_BTN_PWRITE,
	IDC_BTN_AWRITE,
	IDC_BTN_AREAD,
	IDC_BTN_ERASE,
	IDC_BTN_SWRITE,
	IDC_BTN_SREAD,
	IDC_PROGRESS1,
	IDC_BTN_STOP,
	IDC_BTN_LADD,
	IDC_BTN_LDEL,
	IDC_SPIN1,
	IDC_CHK_VERIFY,
	0 };
HANDLE CFlashManGBxDlg::m_hULx = NULL;
u32 CFlashManGBxDlg::m_nRomType = 0;
u32 CFlashManGBxDlg::m_nRomSize = 0;
u32 CFlashManGBxDlg::m_nRomBlkSize = 0;
u32 CFlashManGBxDlg::m_nRomUnuSize = 0;
u32 CFlashManGBxDlg::m_nRamSize = 0;
u32 CFlashManGBxDlg::m_nRamOffset = 0;
TCHAR CFlashManGBxDlg::m_szGameTitle[MAX_MULTI_GAMES][MAX_GAME_TITLE + 1];
TCHAR CFlashManGBxDlg::m_szRomFName[MAX_MULTI_GAMES][MAX_PATH];
u32 CFlashManGBxDlg::m_nCartType[MAX_MULTI_GAMES];
u32 CFlashManGBxDlg::m_nGameSize[MAX_MULTI_GAMES];
u32 CFlashManGBxDlg::m_nSaveSize[MAX_MULTI_GAMES];
int CFlashManGBxDlg::m_nProgress = 0;
BOOL CFlashManGBxDlg::m_bAbort = FALSE;
BOOL CFlashManGBxDlg::m_bStop = FALSE;
CString CFlashManGBxDlg::m_strFileName = _T("");
u32 CFlashManGBxDlg::m_nEraseOfs = 0;
u8 CFlashManGBxDlg::m_buf[BLOCK_SIZE];
const u8 CFlashManGBxDlg::m_ulxfm[] =
#include "ulx_firm.h"
;

// CFlashManGBxDlg _CAO



CFlashManGBxDlg::CFlashManGBxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFlashManGBxDlg::IDD, pParent)
	, m_strDevName(_T(""))
	, m_pThread(NULL)
	, m_nTimer(NULL)
	, m_nReservedSize(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hIconAdd = AfxGetApp()->LoadIcon(IDI_OPEN);
	m_hIconDel = AfxGetApp()->LoadIcon(IDI_DEL);
}

void CFlashManGBxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_ROM, m_list_rom_ctrl);
}

BEGIN_MESSAGE_MAP(CFlashManGBxDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_THREADFINISHED, OnThreadFinished)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_STOP, OnBnClickedBtnStop)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BTN_AREAD, OnBnClickedBtnAread)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_ROM, OnLvnItemchangedListRom)
	ON_BN_CLICKED(IDC_BTN_SREAD, OnBnClickedBtnSread)
	ON_BN_CLICKED(IDC_BTN_SWRITE, OnBnClickedBtnSwrite)
	ON_BN_CLICKED(IDC_BTN_ERASE, OnBnClickedBtnErase)
	ON_BN_CLICKED(IDC_BTN_AWRITE, OnBnClickedBtnAwrite)
	ON_BN_CLICKED(IDC_BTN_PWRITE, OnBnClickedBtnPwrite)
	ON_BN_CLICKED(IDC_BTN_LADD, OnBnClickedBtnLadd)
	ON_BN_CLICKED(IDC_BTN_LDEL, OnBnClickedBtnLdel)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CFlashManGBxDlg bZ[W nh

BOOL CFlashManGBxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	((CButton*)GetDlgItem(IDC_BTN_LADD))->SetIcon(m_hIconAdd);
	((CButton*)GetDlgItem(IDC_BTN_LDEL))->SetIcon(m_hIconDel);
	CString msg;
	if ( !DownloadULxFirm() )
	{
		AfxMessageBox(MULTI_LANG("EZ-USB ܂łB", "Could NOT find EZ-USB."));
		OnCancel();
		return TRUE;
	}
	// V Firm ŋN̂ňxN[Y
	::CloseHandle(m_hULx);
	m_hULx = INVALID_HANDLE_VALUE;
	Sleep(500);
	// V Firm NADeviceDriver ǂݍ܂̂҂
	for ( u32 i = 0; m_hULx == INVALID_HANDLE_VALUE; i = (i + 1) % 3 )
	{
		Sleep(100);
		m_strDevName.Format(_T("\\\\.\\ezusb-%d"), i);
		m_hULx = ::CreateFile(m_strDevName,
			GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	}

	m_list_rom_ctrl.SetExtendedStyle(m_list_rom_ctrl.GetExtendedStyle() | LVS_EX_FULLROWSELECT);
	TCHAR title[][20] = { MULTI_LANG("Q[", "Name of Game"),
		MULTI_LANG("JZbg̎", "Cartridge Type"), MULTI_LANG("ROM TCY", "ROM Size"),
		MULTI_LANG("RAM TCY", "RAM Size") };
	int width[] = { 160, 180, 80, 80 };
	int fmt[] = { 0, 0, LVCFMT_RIGHT, LVCFMT_RIGHT };
	LV_COLUMN listcol;
	listcol.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
	for ( int i = 0; i < sizeof(title) / sizeof(title[0]); i++ ) {
		listcol.pszText = title[i];
		listcol.cx = width[i];
		listcol.fmt = fmt[i];
		m_list_rom_ctrl.InsertColumn(i, &listcol);
	}
	if ( m_imageList.GetSafeHandle() == NULL )
	{
		CBitmap bitmap;
		m_imageList.Create(16, 16, TRUE, 1, 1);
		bitmap.LoadBitmap(IDB_PACKED);
		m_imageList.Add(&bitmap, RGB(0xFF, 0xFF, 0xFF));
		bitmap.DeleteObject();
		bitmap.LoadBitmap(IDB_RESVED);
		m_imageList.Add(&bitmap, RGB(0xFF, 0xFF, 0xFF));
		bitmap.DeleteObject();
	}
	m_list_rom_ctrl.SetImageList(&m_imageList, LVSIL_SMALL);

	// c[qgRg[쐬܂
	m_toolTipCtrl.Create( this );
	for ( int i = 0; m_iToolTipItems[i] != 0; i++ )
	{
		msg.LoadString(m_iToolTipItems[i]);
		m_toolTipCtrl.AddTool(GetDlgItem(m_iToolTipItems[i]), msg);
	}
	BtnEnable(FALSE);
	m_bAbort = FALSE;
	m_bStop = TRUE;
	m_nTimer = NULL;
	m_pThread = AfxBeginThread(CFlashManGBxDlg::InitULx, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CFlashManGBxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CFlashManGBxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CFlashManGBxDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CFlashManGBxDlg::DownloadULxFirm()
{
	unsigned long nByte;
	BOOL result = FALSE;
	VENDOR_REQUEST_IN vreq;

	for ( u32 i = 0; i < 3; i++ )
	{
		m_strDevName.Format(_T("\\\\.\\ezusb-%d"), i);
		m_hULx = ::CreateFile(m_strDevName,
			GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
		if ( m_hULx != INVALID_HANDLE_VALUE ) break;
	}
	if ( m_hULx != INVALID_HANDLE_VALUE )
	{
		TCHAR path[MAX_PATH], drive[_MAX_DRIVE], dir[_MAX_DIR];
		u8 buf[ULXFM_LEN];
		u32 len;
		::GetModuleFileName(AfxGetApp()->m_hInstance, path, MAX_PATH);
		_tsplitpath(path, drive, dir, NULL, NULL);
		_tmakepath(path, drive, dir, _T(ULXFM_NAME), NULL);
		CFile file;
		if ( file.Open(path, CFile::modeRead) )
		{
			len = file.Read(buf, ULXFM_LEN);
			file.Close();
		}
		else
		{
			len = sizeof(m_ulxfm);
			ASSERT(len <= ULXFM_LEN);
			memcpy(buf, m_ulxfm, len);
		}

//		AfxMessageBox(_T("EZ-USB halt"));
		//
		// Firmware download
		//
		// EZ-USB halt
		vreq.bRequest = 0xA0;
		vreq.wValue = 0x7F92;
		vreq.wIndex = 0x00;
		vreq.wLength = 0x01;
		vreq.bData = 1;
		vreq.direction = 0x00;
		result = ::DeviceIoControl(m_hULx,
							IOCTL_Ezusb_VENDOR_REQUEST,
							&vreq,
							sizeof(VENDOR_REQUEST_IN),
							NULL,
							0,
							&nByte,
							NULL);
		if ( result == FALSE ) {
			AfxMessageBox(_T("EZ-USB halt error !!"));
			return FALSE;
		}
//		AfxMessageBox(_T("EZ-USB firmware download"));
		// EZ-USB firmware download
		result = ::DeviceIoControl(m_hULx,
							IOCTL_Ezusb_ANCHOR_DOWNLOAD,
							buf,
							len,
							NULL,
							0,
							&nByte,
							NULL);
		if ( result == FALSE ) {
			AfxMessageBox(_T("EZ-USB Firmware download error !!"));
			return FALSE;
		}
//		AfxMessageBox(_T("EZ-USB run"));
		// EZ-USB Run
		vreq.bRequest = 0xA0;
		vreq.wValue = 0x7F92;
		vreq.wIndex = 0x00;
		vreq.wLength = 0x01;
		vreq.bData = 0;
		vreq.direction = 0x00;
		result = ::DeviceIoControl(m_hULx,
							IOCTL_Ezusb_VENDOR_REQUEST,
							&vreq,
							sizeof(VENDOR_REQUEST_IN),
							NULL,
							0,
							&nByte,
							NULL);
		if ( result == FALSE ) {
			AfxMessageBox(_T("EZ-USB run error !!"));
			return FALSE;
		}
//		AfxMessageBox(_T("EZ-USB has been ULA"));
		return TRUE;
	}
	return FALSE;
}

BOOL CFlashManGBxDlg::SetCmdToULx(u8 nCmd, u32 p1, u32 p2, u32 p3)
{
	u8 ulaBuf[COMMAND_SIZE];
	unsigned long nByte;
	BOOL result = FALSE;
	BULK_TRANSFER_CONTROL bulkControl;
	ulaBuf[ 0] = nCmd;
	ulaBuf[ 1] = (u8)(p1 >>  0);
	ulaBuf[ 2] = (u8)(p1 >>  8);
	ulaBuf[ 3] = (u8)(p1 >> 16);
	ulaBuf[ 4] = (u8)(p1 >> 24);
	ulaBuf[ 5] = (u8)(p2 >>  0);
	ulaBuf[ 6] = (u8)(p2 >>  8);
	ulaBuf[ 7] = (u8)(p2 >> 16);
	ulaBuf[ 8] = (u8)(p2 >> 24);
	ulaBuf[ 9] = (u8)(p3 >>  0);
	ulaBuf[10] = (u8)(p3 >>  8);
	ulaBuf[11] = (u8)(p3 >> 16);
	ulaBuf[12] = (u8)(p3 >> 24);

	bulkControl.pipeNum = BULK_OUT_PIPE;
	result = ::DeviceIoControl(m_hULx,
						IOCTL_EZUSB_BULK_WRITE,
						&bulkControl,
						sizeof(BULK_TRANSFER_CONTROL),
						ulaBuf,
						COMMAND_SIZE,
						&nByte,
						NULL);
	return result;
}

BOOL CFlashManGBxDlg::WriteULx(u8 *pData, u32 len)
{
	unsigned long nByte;
	BOOL result = FALSE;
	BULK_TRANSFER_CONTROL bulkControl;

	bulkControl.pipeNum = BULK_OUT_PIPE;
	result = ::DeviceIoControl(m_hULx,
						IOCTL_EZUSB_BULK_WRITE,
						&bulkControl,
						sizeof(BULK_TRANSFER_CONTROL),
						pData,
						len,
						&nByte,
						NULL);
	return result;
}

BOOL CFlashManGBxDlg::ReadULx(u8 *pData, u32 len)
{
	unsigned long nByte;
	BOOL result = FALSE;
	BULK_TRANSFER_CONTROL bulkControl;

	bulkControl.pipeNum = BULK_IN_PIPE;
	result = ::DeviceIoControl(m_hULx,
						IOCTL_EZUSB_BULK_READ,
						&bulkControl,
						sizeof(BULK_TRANSFER_CONTROL),
						pData,
						len,
						&nByte,
						NULL);
	return result;
}

void CFlashManGBxDlg::AbortULx()
{
	unsigned long nByte;
	BOOL result = FALSE;
	ULONG pipe = BULK_IN_PIPE;
	HANDLE hULx;
	hULx = ::CreateFile(m_strDevName,
		GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if ( hULx != INVALID_HANDLE_VALUE )
	{
		result = ::DeviceIoControl(hULx, IOCTL_Ezusb_ABORTPIPE,
			&pipe, sizeof(pipe), NULL, 0, &nByte, NULL);
		pipe = BULK_OUT_PIPE;
		result = ::DeviceIoControl(hULx, IOCTL_Ezusb_ABORTPIPE,
			&pipe, sizeof(pipe), NULL, 0, &nByte, NULL);
//		for ( pipe = 0; pipe <= BULK_OUT_PIPE; pipe++ )
//			result = ::DeviceIoControl(m_hULA, IOCTL_Ezusb_RESETPIPE,
//				&pipe, sizeof(pipe), NULL, 0, &nByte, NULL);
		::CloseHandle(hULx);
	}
}

CString CFlashManGBxDlg::GetStrSize(u32 m, BOOL bShort)
{
	CString str;
	if ( m < 1024 )
		str.Format(bShort?_T("%d"):_T("%dbit"), m / (1024 / 8));
	else if ( m < 1024 * 1024 )
		str.Format(bShort?_T("%dK"):_T("%dKbit"), m / (1024 / 8));
	else
		str.Format(bShort?_T("%dM"):_T("%dMbit"), m / (1024 * 1024 / 8));
	return str;
}

const u8 CFlashManGBxDlg::m_cartLogo[] = {
	0xce,0xed,0x66,0x66,0xcc,0x0d,0x00,0x0b,
	0x03,0x73,0x00,0x83,0x00,0x0c,0x00,0x0d,
	0x00,0x08,0x11,0x1f,0x88,0x89,0x00,0x0e,
	0xdc,0xcc,0x6e,0xe6,0xdd,0xdd,0xd9,0x99,
	0xbb,0xbb,0x67,0x63,0x6e,0x0e,0xec,0xcc,
	0xdd,0xdc,0x99,0x9f,0xbb,0xb9,0x33,0x3e
};

UINT CFlashManGBxDlg::InitULx(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	if ( m_bAbort ) goto THREADFINISH;
	::EnableWindow(::GetDlgItem((HWND)pParam, IDC_BTN_STOP), FALSE);
	m_nProgress = 100;
	::GetWindowText((HWND)pParam, szWin, 256);
	str.Format(MULTI_LANG("%s - GB Xchanger o...", "%s - Detecting GB Xchanger..."), szWin);
	::SetWindowText((HWND)pParam, str);
	do
	{
		SetCmdToULx(TARGET_INIT, 0, 0, 0);
		ReadULx(m_buf, RESPONSE_SIZE);
		if ( m_bAbort ) goto THREADFINISH;
	}
	while ( m_buf[0] );
	str.Format(MULTI_LANG("%s - GBx JZbg͒...", "%s - Analyzing the GBx Cartridge..."), szWin);
	::SetWindowText((HWND)pParam, str);

	GetCartInfoULx();

THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	::EnableWindow(::GetDlgItem((HWND)pParam, IDC_BTN_STOP), TRUE);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

void CFlashManGBxDlg::GetCartInfoULx()
{
	ASSERT(MAX_ROM_HEADER >= RESPONSE_SIZE);
	u8 buf[MAX_ROM_HEADER];
	u32 *pBuf = (u32*)buf;

	SetCmdToULx(GBXCH_CART_PROBE, 0, 0, 0);
	ReadULx(buf, RESPONSE_SIZE);
	m_nRomType = *(pBuf + 0);
	m_nRomSize = *(pBuf + 1);
	m_nRomBlkSize = *(pBuf + 2);
	if ( m_bAbort ) return;

	if ( m_nRomType & 0xFF )
	{
		for ( u32 i = 0; i < m_nRomSize; i += BLOCK_SIZE )
		{
			SetCmdToULx(GBXCH_READ, m_nRomSize - i - BLOCK_SIZE + ROM_HEADER_OFST, MAX_ROM_HEADER, 0);
			ReadULx(buf, MAX_ROM_HEADER);
			if ( m_bAbort ) return;
			for ( u32 j = 0; j < MAX_ROM_HEADER; j++ )
				if ( buf[j] != 0xFF ) break;
			if ( j != MAX_ROM_HEADER ) break;
		}
		m_nRomUnuSize = i;
	}
	else
		m_nRomUnuSize = 0;

	m_nCartType[0] = 0;
	m_nGameSize[0] = 0;
	m_nSaveSize[0] = 0;
	::ZeroMemory(m_szGameTitle, sizeof(m_szGameTitle));
	u32 adr = ROM_HEADER_OFST;
	if ( m_nRomSize > 0 )
	{
		for ( u32 i = 0; i < MAX_MULTI_GAMES; i++ )
		{
			if ( adr > m_nRomSize - m_nRomUnuSize )
			{
				m_nCartType[i] = 0;
				m_nGameSize[i] = 0;
				m_nSaveSize[i] = 0;
				break;
			}
			SetCmdToULx(GBXCH_READ, adr, MAX_ROM_HEADER, 0);
			ReadULx(buf, MAX_ROM_HEADER);
			if ( m_bAbort ) return;
			if ( memcmp(buf+CART_LOGO_OFST, m_cartLogo, sizeof(m_cartLogo)) )
			{
				m_nCartType[i] = 0;
				m_nGameSize[i] = 0;
				m_nSaveSize[i] = 0;
				break;
			}
			for ( u32 j = 0; j < MAX_GAME_TITLE; j++ )
				m_szGameTitle[i][j] = (TCHAR)buf[j+CART_LOGO_OFST+sizeof(m_cartLogo)];
			if ( m_szGameTitle[i][MAX_GAME_TITLE-1] == 0x80 ||
				 m_szGameTitle[i][MAX_GAME_TITLE-1] == 0xC0 )
				m_szGameTitle[i][MAX_GAME_TITLE-1] = '\0';
			else
				m_szGameTitle[i][MAX_GAME_TITLE] = '\0';
			m_nCartType[i] = buf[CART_TYPE_OFST];
			m_nGameSize[i] = GetRomSize(buf[ROM_SIZE_OFST]);
			m_nSaveSize[i] = GetRamSize(buf[RAM_SIZE_OFST]);
			adr += m_nGameSize[i];
		}
	}
	m_nRomUnuSize = min(m_nRomUnuSize, m_nRomSize - GetTailOfs());
}

u32 CFlashManGBxDlg::GetTailOfs()
{
	u32 ofs = 0;
	for ( int i = 0; i < MAX_MULTI_GAMES; i++ )
		if ( (m_nGameSize[i] == 0 && m_nSaveSize[i] == 0) )
			break;
		else
			ofs += m_nGameSize[i];
	return ofs;
}

u32 CFlashManGBxDlg::GetRomSize(u8 d)
{
	switch ( d )
	{
	case 0x52:
		return 16*1024 * 72;
		break;
	case 0x53:
		return 16*1024 * 80;
		break;
	case 0x54:
		return 16*1024 * 96;
		break;
	default:
		return (32*1024) << d;
	}
}

u32 CFlashManGBxDlg::GetRamSize(u8 d)
{
    switch ( d )
	{
	case 1:
		return 2*1024;
		break;
	case 2:
		return 8*1024;
		break;
	case 3:
		return 32*1024;
		break;
	case 4:
		return 128*1024;
		break;
	default:
		return 0;
	}
}

UINT CFlashManGBxDlg::ReadRom(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeCreate | CFile::modeWrite) )
	{
		str.Format(MULTI_LANG(
			"t@C(%s)쐬邱Ƃł܂B\n"
			"ݐ̃hCȕԂmFĂB",
			"Can NOT create the file(%s).\n"
			"Check your drive state which you will write to."), m_strFileName);
		::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRomSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRomSize;
		if ( m_nProgress != nProgress )
		{
			str.Format(MULTI_LANG("%d%% %s - vOf[^ǂݍݒ... (o: %s)",
				"%d%% %s - Reading Program Code... (Output: %s)"), m_nProgress, szWin, m_strFileName);
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		SetCmdToULx(GBXCH_READ, i, BLOCK_SIZE, 0);
		ReadULx(m_buf, BLOCK_SIZE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
		file.Write(m_buf, BLOCK_SIZE);
	}
	file.Close();

THREADFINISH:
	if ( m_bStop || m_bAbort )
	{
		TRY
			CFile::Remove(m_strFileName);
		CATCH(CFileException, e)
		END_CATCH
	}
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManGBxDlg::EraseRom(LPVOID pParam)
{
	u8 buf[RESPONSE_SIZE];
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	// ZN^[Pʂł͂ȂItZbĝƂ
	u32 diff = m_nEraseOfs % m_nRomBlkSize;
	u32 ofs = m_nEraseOfs - diff;
	u8 *pBuf = NULL;
	if ( diff )
	{
		pBuf = new u8[diff];
		if ( pBuf == NULL )
		{
			::MessageBox((HWND)pParam, MULTI_LANG(
				"̊mۂł܂łB",
				"Could NOT allocate memory."), AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		::SetWindowText((HWND)pParam, MULTI_LANG(
			"vOf[^obNAbv...", "Backup Program Code..."));
		for ( u32 i = 0; i < diff; i += BLOCK_SIZE )
		{
			SetCmdToULx(GBXCH_READ, i + ofs, BLOCK_SIZE, 0);
			ReadULx(pBuf + i, BLOCK_SIZE);
			if ( m_bStop || m_bAbort ) goto THREADFINISH;
		}
	}
	for ( u32 i = ofs; i < m_nRomSize; i += m_nRomBlkSize )
	{
		m_nProgress = (i - ofs) * 100 / (m_nRomSize - ofs);
		if ( m_nProgress != nProgress )
		{
			str.Format(MULTI_LANG("%d%% %s - vOf[^...",
				"%d%% %s - Erasing Program Code..."), m_nProgress, szWin);
			::SetWindowText((HWND)pParam, str);
		}
		SetCmdToULx(GBXCH_ROM_BERASE, i, 0, 0);
		ReadULx(buf, RESPONSE_SIZE);
		if ( buf[0] )
		{
			::MessageBox((HWND)pParam, MULTI_LANG(
				"JZbgɃG[܂B",
				"Error occurs while erasing the cartridge."), AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		if ( m_bStop || m_bAbort ) goto THREADFINISH;
	}
	// ZN^[Pʂł͂ȂItZbĝƂ
	if ( diff && pBuf )
	{
		::SetWindowText((HWND)pParam, MULTI_LANG(
			"vOf[^...", "Restore Program Code..."));
		for ( u32 i = 0; i < diff; i += BLOCK_SIZE )
		{
			SetCmdToULx(GBXCH_ROM_WRITE, i + ofs, BLOCK_SIZE, 0);
			WriteULx(pBuf + i, BLOCK_SIZE);
			if ( m_bStop || m_bAbort ) goto THREADFINISH;
			ReadULx(buf, RESPONSE_SIZE);
			if ( m_bStop || m_bAbort ) goto THREADFINISH;
			if ( buf[0] )
			{
				::MessageBox((HWND)pParam, MULTI_LANG(
					"JZbgݒɃG[܂B",
					"Error occurs while writing the cartridge."), AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
				goto THREADFINISH;
			}
		}
	}
	if ( pBuf ) delete[] pBuf;
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	return InitULx(pParam);
}

UINT CFlashManGBxDlg::WritePreBoot(LPVOID pParam)
{
	u8 buf[RESPONSE_SIZE];
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	for ( int s = 0; s < MAX_MULTI_GAMES; s++ )
		if ( m_szRomFName[s][0] ) break;
	for ( int e = s; e < MAX_MULTI_GAMES; e++ )
		if ( m_szRomFName[e][0] == '\0' ) break;
	if ( s == MAX_MULTI_GAMES ) goto THREADFINISH;
	u32 tlen = 0;
	u32 flen = 0;
	for ( int i = s; i < e; i++ )
		tlen += m_nGameSize[i];
	u32 dev_ofs = 0;
	for ( ; s < e; s++ )
	{
		if ( !file.Open(m_szRomFName[s], CFile::modeRead) )
		{
			str.Format(MULTI_LANG(
				"t@C(%s)JƂł܂B\n"
				"ǂݍݐ̃hCȕԂmFĂB",
				"Can NOT open the file(%s).\n"
				"Check your drive which you will read from."), m_szRomFName[s]);
			::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		u32 len = m_nGameSize[s];
		if ( m_nRomSize < len + dev_ofs )
		{
			file.Close();
			str.Format(MULTI_LANG(
				"t@C(%s)̑傫\n"
				"tbVJZbg̗eʂ𒴂Ă܂B",
				"The file(%s) size is LARGER than\n"
				"whole capacity of Flash Cartridge."), m_szRomFName[s]);
			::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		for ( u32 i = 0; i < len; i += BLOCK_SIZE )
		{
			m_nProgress = (flen + i) * 100 / tlen;
			if ( m_nProgress != nProgress )
			{
				str.Format(MULTI_LANG(
					"%d%% %s - vOf[^擪ݒ... (: %s)",
					"%d%% %s - Writing Program Code... (Input: %s)"), m_nProgress, szWin, m_szRomFName[s]);
				::SetWindowText((HWND)pParam, str);
				nProgress = m_nProgress;
			}
			u32 _len = file.Read(m_buf, BLOCK_SIZE);
			SetCmdToULx(GBXCH_ROM_BWRITE, i + dev_ofs, _len, 0);
			WriteULx(m_buf, _len);
			if ( m_bStop || m_bAbort ) {
				file.Close();
				goto THREADFINISH;
			}
			ReadULx(buf, RESPONSE_SIZE);
			if ( m_bStop || m_bAbort ) goto THREADFINISH;
			if ( buf[0] )
			{
				::MessageBox((HWND)pParam, MULTI_LANG(
					"JZbgݒɃG[܂B",
					"Error occurs while writing the cartridge."), AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
				goto THREADFINISH;
			}
		}
		file.Close();
		flen += len;
		dev_ofs += (len + BLOCK_SIZE-1) & ~(BLOCK_SIZE-1);
	}
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	return InitULx(pParam);
}

UINT CFlashManGBxDlg::WriteAppendRom(LPVOID pParam)
{
	u8 buf[RESPONSE_SIZE];
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	for ( int s = 0; s < MAX_MULTI_GAMES; s++ )
		if ( m_szRomFName[s][0] ) break;
	for ( int e = s; e < MAX_MULTI_GAMES; e++ )
		if ( m_szRomFName[e][0] == '\0' ) break;
	u32 tlen = 0;
	u32 flen = 0;
	for ( int i = s; i < e; i++ )
		tlen += m_nGameSize[i];
	u32 dev_ofs = m_nRomSize - (m_nRomUnuSize & ~(BLOCK_SIZE-1));
	for ( ; s < e; s++ )
	{
		if ( !file.Open(m_szRomFName[s], CFile::modeRead) )
		{
			str.Format(MULTI_LANG(
				"t@C(%s)JƂł܂B\n"
				"ǂݍݐ̃hCȕԂmFĂB",
				"Can NOT open the file(%s).\n"
				"Check your drive which you will read from."), m_szRomFName[s]);
			::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		u32 len = m_nGameSize[s];
		if ( m_nRomSize < len + dev_ofs )
		{
			file.Close();
			str.Format(MULTI_LANG(
				"t@C(%s)̑傫\n"
				"tbVJZbg̋󂫗eʂ𒴂Ă܂B",
				"The file(%s) size is LARGER than\n"
				"free capacity of Flash Cartridge."), m_szRomFName[s]);
			::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
			goto THREADFINISH;
		}
		for ( u32 i = 0; i < len; i += BLOCK_SIZE )
		{
			m_nProgress = (flen + i) * 100 / tlen;
			if ( m_nProgress != nProgress )
			{
				str.Format(MULTI_LANG(
					"%d%% %s - vOf[^ǉݒ... (: %s)",
					"%d%% %s - Appending Program Code... (Input: %s)"), m_nProgress, szWin, m_szRomFName[s]);
				::SetWindowText((HWND)pParam, str);
				nProgress = m_nProgress;
			}
			u32 _len = (file.Read(m_buf, BLOCK_SIZE) + 3) & ~3;
			SetCmdToULx(GBXCH_ROM_WRITE, i + dev_ofs, _len, 0);
			WriteULx(m_buf, _len);
			if ( m_bStop || m_bAbort ) {
				file.Close();
				goto THREADFINISH;
			}
			ReadULx(buf, RESPONSE_SIZE);
			if ( m_bStop || m_bAbort ) goto THREADFINISH;
			if ( buf[0] )
			{
				::MessageBox((HWND)pParam, MULTI_LANG(
					"JZbgݒɃG[܂B",
					"Error occurs while writing the cartridge."), AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
				goto THREADFINISH;
			}
		}
		file.Close();
		flen += len;
		dev_ofs += (len + BLOCK_SIZE-1) & ~(BLOCK_SIZE-1);
	}
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	return InitULx(pParam);
}

UINT CFlashManGBxDlg::ReadRam(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeCreate | CFile::modeWrite) )
	{
		str.Format(MULTI_LANG(
			"t@C(%s)쐬邱Ƃł܂B\n"
			"ݐ̃hCȕԂmFĂB",
			"Can NOT create the file(%s).\n"
			"Check your drive state which you will write to."), m_strFileName);
		::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRamSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRamSize;
		if ( m_nProgress != nProgress )
		{
			str.Format(MULTI_LANG(
				"%d%% %s - Z[uf[^ǂݍݒ... (o: %s)",
				"%d%% %s - Reading Save Data... (Output: %s)"), m_nProgress, szWin, m_strFileName);
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 len = m_nRamSize > BLOCK_SIZE ? BLOCK_SIZE : m_nRamSize;
		SetCmdToULx(GBXCH_SRAM_READ, m_nRamOffset + i, len, 0);
		ReadULx(m_buf, len);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
		file.Write(m_buf, len);
	}
	file.Close();

THREADFINISH:
	if ( m_bStop || m_bAbort )
	{
		TRY
			CFile::Remove(m_strFileName);
		CATCH(CFileException, e)
		END_CATCH
	}
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManGBxDlg::WriteRam(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeRead) )
	{
		str.Format(MULTI_LANG(
			"t@C(%s)JƂł܂B\n"
			"ǂݍݐ̃hCȕԂmFĂB",
			"Can NOT open the file(%s).\n"
			"Check your drive which you will read from."), m_strFileName);
		::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
		goto THREADFINISH;
	}
	if ( file.GetLength() != m_nRamSize )
	{
		file.Close();
		str.Format(MULTI_LANG(
			"t@C(%s)̑傫\n"
			"GBA JZbg RAM eʂɈv܂B",
			"The file(%s) size is\n"
			"different from RAM capacity of GBA Cartridge."), m_strFileName, m_nRamSize);
		::MessageBox((HWND)pParam, str, AfxGetAppName(), MB_OK | MB_ICONEXCLAMATION);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRamSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRamSize;
		if ( m_nProgress != nProgress )
		{
			str.Format(MULTI_LANG(
				"%d%% %s - Z[uf[^ݒ... (o: %s)",
				"%d%% %s - Writing Save Data... (Output: %s)"), m_nProgress, szWin, m_strFileName);
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 len = m_nRamSize > BLOCK_SIZE ? BLOCK_SIZE : m_nRamSize;
		file.Read(m_buf, len);
		SetCmdToULx(GBXCH_SRAM_WRITE, m_nRamOffset + i, len, 0);
		WriteULx(m_buf, len);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
	}
	file.Close();

THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

void CFlashManGBxDlg::BtnEnable(BOOL bEnable)
{
	if ( m_nRomSize )
		if ( (u8)m_nRomType )
		{
			GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_ERASE)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_AREAD)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_LADD)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_LDEL)->EnableWindow(bEnable);
			GetDlgItem(IDC_SPIN1)->EnableWindow(bEnable);
		}
		else
		{
			GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_ERASE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_AREAD)->EnableWindow(bEnable);
			GetDlgItem(IDC_BTN_LADD)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_LDEL)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPIN1)->EnableWindow(FALSE);
		}
	else
	{
		GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ERASE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AREAD)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_LADD)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_LDEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPIN1)->EnableWindow(FALSE);
	}
	if ( bEnable )
		ChkRamBtn();
	else
	{
		GetDlgItem(IDC_BTN_SWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_SREAD)->EnableWindow(FALSE);
	}
	GetDlgItem(IDOK)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_STOP)->EnableWindow(!bEnable);
}

void CFlashManGBxDlg::ChkRamBtn()
{
	int i, nItem = -1;
	m_nRamSize = 0;
	m_nRamOffset = 0;
	if ( m_list_rom_ctrl.GetNextItem(-1, LVNI_SELECTED) == -1 )
	{
		// ROM XgɑIꂽQ[Ȃ
		switch ( (u8)m_nRomType )
		{
		case 4:
			m_nRamSize = 32*1024;	// 4 x 8K = 32K
			break;
		case 16:
		case 64:
			m_nRamSize = 128*1024;	// 16 x 8K = 128K
			break;
		default :
			m_nRamSize = m_nSaveSize[0];
		}
	}
	else
	{
		while ( (i = m_list_rom_ctrl.GetNextItem(nItem, LVNI_SELECTED)) != -1 )
			if ( nItem == -1 && m_list_rom_ctrl.GetItemData(i) == NULL )
			{
				m_nRamSize = m_nSaveSize[i];
				nItem = i;
			}
			else
			{
				m_nRamSize = 0;
				nItem = i;
			}
			for ( i = 0; i < nItem; i++ )
				m_nRamOffset += (m_nSaveSize[i] + (RAM_BANK_SIZE-1)) & ~(RAM_BANK_SIZE-1);
	}
	if ( m_nRamSize )
	{
		GetDlgItem(IDC_BTN_SWRITE)->EnableWindow();
		GetDlgItem(IDC_BTN_SREAD)->EnableWindow();
	}
	else
	{
		GetDlgItem(IDC_BTN_SWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_SREAD)->EnableWindow(FALSE);
	}
}

void CFlashManGBxDlg::RefreshCartInfo()
{
	for ( int i = 0; i < m_list_rom_ctrl.GetItemCount(); i++ )
		m_list_rom_ctrl.SetItemState(i, 0, LVIS_SELECTED | LVIS_FOCUSED);
	m_list_rom_ctrl.DeleteAllItems();
	for ( u32 i = 0; i < MAX_MULTI_GAMES; i++ )
	{
		if ( m_nGameSize[i] == 0 && m_nSaveSize[i] == 0 ) break;
		m_list_rom_ctrl.InsertItem(i, m_szGameTitle[i], 0);
		m_list_rom_ctrl.SetItemText(i, 1, GetCartTypeName(m_nCartType[i]));
		m_list_rom_ctrl.SetItemText(i, 2, GetStrSize(m_nGameSize[i]));
		m_list_rom_ctrl.SetItemText(i, 3, GetStrSize(m_nSaveSize[i]));
		m_list_rom_ctrl.SetItemData(i, NULL);
	}
	switch ( (u8)m_nRomType )
	{
	case 4:
		SetDlgItemText(IDC_STC_ROMTYPE, _T("FLASH ") + GetStrSize(m_nRomSize));
		SetDlgItemText(IDC_STC_RAMTYPE, _T("SRAM ") + GetStrSize(32*1024));
		break;
	case 16:
	case 64:
		SetDlgItemText(IDC_STC_ROMTYPE, _T("FLASH ") + GetStrSize(m_nRomSize));
		SetDlgItemText(IDC_STC_RAMTYPE, _T("SRAM ") + GetStrSize(128*1024));
		break;
	default :
		if ( m_nRomSize )
			SetDlgItemText(IDC_STC_ROMTYPE, _T("MASK ") + GetStrSize(m_nRomSize));
		else
			SetDlgItemText(IDC_STC_ROMTYPE, _T("NONE"));
		if ( m_nSaveSize[0] )
			SetDlgItemText(IDC_STC_RAMTYPE, _T("SRAM ") + GetStrSize(m_nSaveSize[0]));
		else
			SetDlgItemText(IDC_STC_RAMTYPE, _T("NONE"));
		break;
	}
	m_nReservedSize = 0;
	SetDlgItemText(IDC_STC_ROMFREE,
		GetStrSize(m_nRomUnuSize - m_nReservedSize, TRUE) + _T("/") +
		GetStrSize((u8)m_nRomType ? m_nRomSize - m_nReservedSize : 0));
	::ZeroMemory(m_szRomFName, sizeof(m_szRomFName));
}

const TCHAR* CFlashManGBxDlg::GetCartTypeName(u8 d)
{
	switch ( d )
	{
	case 0x00:
		return _T("ROM only");
		break;
	case 0x01:
		return _T("ROM+MBC1");
		break;
	case 0x02:
		return _T("ROM+MBC1+RAM");
		break;
	case 0x03:
		return _T("ROM+MBC1+RAM+BATTERY");
		break;
	case 0x05:
		return _T("ROM+MBC2");
		break;
	case 0x06:
		return _T("ROM+MBC2+BATTERY");
		break;
	case 0x08:
		return _T("ROM+RAM");
		break;
	case 0x09:
		return _T("ROM+RAM+BATTERY");
		break;
	case 0x0B:
		return _T("ROM+MMM01");
		break;
	case 0x0C:
		return _T("ROM+MMM01+SRAM");
		break;
	case 0x0D:
		return _T("ROM+MMM01+SRAM+BATTERY");
		break;
	case 0x0F:
		return _T("ROM+MBC3+TIMER+BATTERY");
		break;
	case 0x10:
		return _T("ROM+MBC3+TIMER+RAM+BATTERY");
		break;
	case 0x11:
		return _T("ROM+MBC3");
		break;
	case 0x12:
		return _T("ROM+MBC3+RAM");
		break;
	case 0x13:
		return _T("ROM+MBC3+RAM+BATTERY");
		break;
	case 0x19:
		return _T("ROM+MBC5");
		break;
	case 0x1A:
		return _T("ROM+MBC5+RAM");
		break;
	case 0x1B:
		return _T("ROM+MBC5+RAM+BATTERY");
		break;
	case 0x1C:
		return _T("ROM+MBC5+RUMBLE");
		break;
	case 0x1D:
		return _T("ROM+MBC5+RUMBLE+SRAM");
		break;
	case 0x1E:
		return _T("ROM+MBC5+RUMBLE+SRAM+BATTERY");
		break;
	case 0x1F:
		return _T("Pocker Camera");
		break;
	case 0xFD:
		return _T("Bandai TAMA5");
		break;
	case 0xFE:
		return _T("Hudson HuC-3");
		break;
	case 0xFF:
		return _T("Hudson HuC-1");
		break;
	default :
		return _T("Not define");
		break;
	}
}

LRESULT CFlashManGBxDlg::OnThreadFinished(WPARAM wParam, LPARAM lParam)
{
	BtnEnable();
	if ( m_nTimer )
	{
		KillTimer(m_nTimer);
		m_nTimer = 0;
		m_nProgress = 0;
		((CProgressCtrl*)GetDlgItem(IDC_PROGRESS1))->SetPos(m_nProgress);
	}
	RefreshCartInfo();
	m_pThread = NULL;
	if ( m_bAbort ) OnCancel();
	if ( !m_bStop && !m_bAbort )
	{
		if ( IsIconic() )
		{
			WINDOWPLACEMENT wp;
			wp.length = sizeof(wp);
			GetWindowPlacement(&wp);
			wp.showCmd = SW_RESTORE;
			SetWindowPlacement(&wp);
		}
		SetWindowPos(&wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
		AfxMessageBox(MULTI_LANG(
			"܂B", "Process has been completed."), MB_ICONINFORMATION);
	}
	return 0;
}

void CFlashManGBxDlg::OnTimer(UINT nIDEvent)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if ( m_nTimer == nIDEvent )
		((CProgressCtrl*)GetDlgItem(IDC_PROGRESS1))->SetPos(m_nProgress);

	CDialog::OnTimer(nIDEvent);
}

BOOL CFlashManGBxDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	switch ( pMsg->message )
	{
	case WM_LBUTTONDOWN :
	case WM_LBUTTONUP :
	case WM_MOUSEMOVE :
		// }EX bZ[Wc[ qg Rg[ɓnď܂
		m_toolTipCtrl.RelayEvent( pMsg );
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CFlashManGBxDlg::OnBnClickedBtnStop()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	m_bStop = TRUE;
}

void CFlashManGBxDlg::OnBnClickedCancel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if ( m_pThread )
	{
		m_pThread->SuspendThread();
		if ( AfxMessageBox(MULTI_LANG(
			"słI܂?",
			"Really ABORT the processing?"),
			MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES )
		{
			AbortULx();
			m_bAbort = TRUE;
		}
		m_pThread->ResumeThread();
	}
	else
	{
		SetCmdToULx(TARGET_END, 0, 0, 0);
		OnCancel();
	}
}

const TCHAR CFlashManGBxDlg::m_szPrgFilter[] = MULTI_LANG(
	"vOf[^(*.gbc *.sgb *.gb *.bin)|*.gbc; *.sgb; *.gb; *.bin|SẴt@C(*.*)|*.*||",
	"Program Code(*.gbc *.sgb *.gb *.bin)|*.gbc; *.sgb; *.gb; *.bin|All Files(*.*)|*.*||");
const TCHAR CFlashManGBxDlg::m_szSavFilter[] = MULTI_LANG(
	"Z[uf[^(*.sav *.dat)|*.sav; *.dat|SẴt@C(*.*)|*.*||",
	"Save Data(*.sav *.dat)|*.sav; *.dat|All Files(*.*)|*.*||");

void CFlashManGBxDlg::OnBnClickedBtnAread()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(FALSE, _T("gbc"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szPrgFilter, this, 0 );
	fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
		"vOf[^(ROM)ۑ",
		"Save Program Code(ROM)");
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManGBxDlg::ReadRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManGBxDlg::OnBnClickedBtnErase()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	int nItem = -1;
	for ( int i = 0; i < m_list_rom_ctrl.GetItemCount(); i++ )
		if ( m_list_rom_ctrl.GetItemData(i) == NULL )
			if ( nItem != -1 && m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED) == 0 )
			{
				AfxMessageBox(MULTI_LANG(
					"Q[̓tbVJZbg̍Ō܂ŘAĂȂ΂Ȃ܂B",
					"You have to select game sequentially to erase to end of Flash Cartridge."));
				return;
			}
			else if ( nItem == -1 && m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED) )
				nItem = i;

	CString msg;
	if ( nItem == -1 )
	{
		msg = MULTI_LANG(
			"tbVJZbgSĂ낵ł?",
			"Really ERASE the whole Flash Cartridge?");
		m_nEraseOfs = 0;
	}
	else
	{
		msg = MULTI_LANG(
			"IꂽQ[Ă낵ł?",
			"Really ERASE the selected games?");
		m_nEraseOfs = 0;
		for ( int i = 0; i < nItem; i++ )
			m_nEraseOfs += m_nGameSize[i];
		ASSERT(m_nEraseOfs <= m_nRomSize);
	}
	if ( AfxMessageBox(msg,
		MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES )
	{
		BtnEnable(FALSE);
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManGBxDlg::EraseRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManGBxDlg::OnBnClickedBtnPwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	for ( int i = 0; i < min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()); i++ )
		if ( m_list_rom_ctrl.GetItemData(i) ) break;
	if ( i == min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()) )
	{
		// Xgɗ\t@C
		CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, m_szPrgFilter, this, 0 );
		fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
			"vOf[^(ROM)J",
			"Open Program Code(ROM)");
		if ( fileDlg.DoModal() == IDOK )
		{
			u8 d = 0;
			CFile f;
			BtnEnable(FALSE);
			if ( f.Open(fileDlg.GetPathName(), CFile::modeRead) )
			{
				f.Seek(ROM_HEADER_OFST+ROM_SIZE_OFST, CFile::begin);
				f.Read(&d, sizeof(d));
				f.Close();
				_tcsncpy(m_szRomFName[0], fileDlg.GetPathName(), MAX_PATH);
				m_nGameSize[0] = GetRomSize(d);
				m_bAbort = FALSE;
				m_bStop = FALSE;
				if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
				m_pThread = AfxBeginThread(CFlashManGBxDlg::WritePreBoot, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
			}
		}
	}
	else
	{
		// Xgɗ\t@C
		if ( AfxMessageBox(MULTI_LANG(
			"Xgɂ\t@CJZbgɏ㏑܂?",
			"Over write reserved files in the list to cartridge?"),
			MB_ICONQUESTION | MB_YESNO) == IDYES )
		{
			BtnEnable(FALSE);
			m_bAbort = FALSE;
			m_bStop = FALSE;
			if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
			m_pThread = AfxBeginThread(CFlashManGBxDlg::WritePreBoot, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
		}
	}
}

void CFlashManGBxDlg::OnBnClickedBtnAwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	for ( int i = 0; i < min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()); i++ )
		if ( m_list_rom_ctrl.GetItemData(i) ) break;
	if ( i == min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()) )
	{
		// Xgɗ\t@C
		CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, m_szPrgFilter, this, 0 );
		fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
			"vOf[^(ROM)J",
			"Open Program Code(ROM)");
		if ( fileDlg.DoModal() == IDOK )
		{
			u8 d = 0;
			CFile f;
			BtnEnable(FALSE);
			if ( f.Open(fileDlg.GetPathName(), CFile::modeRead) )
			{
				f.Seek(ROM_HEADER_OFST+ROM_SIZE_OFST, CFile::begin);
				f.Read(&d, sizeof(d));
				f.Close();
				_tcsncpy(m_szRomFName[0], fileDlg.GetPathName(), MAX_PATH);
				m_nGameSize[0] = GetRomSize(d);
				m_bAbort = FALSE;
				m_bStop = FALSE;
				if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
				m_pThread = AfxBeginThread(CFlashManGBxDlg::WriteAppendRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
			}
		}
	}
	else
	{
		// Xgɗ\t@C
		if ( AfxMessageBox(MULTI_LANG(
			"Xgɂ\t@CJZbgɒǉ݂܂?",
			"Append write reserved files in the list to cartridge?"),
			MB_ICONQUESTION | MB_YESNO) == IDYES )
		{
			BtnEnable(FALSE);
			m_bAbort = FALSE;
			m_bStop = FALSE;
			if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
			m_pThread = AfxBeginThread(CFlashManGBxDlg::WriteAppendRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
		}
	}
}

void CFlashManGBxDlg::OnBnClickedBtnSread()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(FALSE, _T("sav"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szSavFilter, this, 0 );
	fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
		"Z[uf[^(RAM)ۑ",
		"Save Save Data(RAM)");
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManGBxDlg::ReadRam, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManGBxDlg::OnBnClickedBtnSwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szSavFilter, this, 0 );
	fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
		"Z[uf[^(RAM)J",
		"Open Save Data(RAM)");
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManGBxDlg::WriteRam, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManGBxDlg::OnLvnItemchangedListRom(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	ChkRamBtn();
	*pResult = 0;
}

void CFlashManGBxDlg::OnBnClickedBtnLadd()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, m_szPrgFilter, this, 0 );
	fileDlg.m_ofn.lpstrTitle = MULTI_LANG(
		"XgɒǉvOf[^(ROM)J",
		"Open Program Code(ROM) to add to list");
	if ( fileDlg.DoModal() == IDOK )
	{
		POSITION pos = fileDlg.GetStartPosition();
		CFile f;
		u8 buf[MAX_ROM_HEADER];
		u32 i = m_list_rom_ctrl.GetItemCount();
		for ( ; i < MAX_MULTI_GAMES && pos != NULL; )
		{
			_tcsncpy(m_szRomFName[i], fileDlg.GetNextPathName(pos), MAX_PATH);
			if ( !f.Open(m_szRomFName[i], CFile::modeRead) ) continue;
			if ( f.Seek(ROM_HEADER_OFST, CFile::begin) != ROM_HEADER_OFST ) continue;
			if ( f.Read(buf, MAX_ROM_HEADER) != MAX_ROM_HEADER ) continue;
			f.Close();
			if ( memcmp(buf+CART_LOGO_OFST, m_cartLogo, sizeof(m_cartLogo)) != 0 ) continue;
			m_nGameSize[i] = GetRomSize(buf[ROM_SIZE_OFST]);
			if ( !ChkReservedSize(m_nGameSize[i]) ) break;
			for ( u32 j = 0; j < MAX_GAME_TITLE; j++ )
				m_szGameTitle[i][j] = (TCHAR)buf[CART_LOGO_OFST+sizeof(m_cartLogo)+j];
			m_szGameTitle[i][MAX_GAME_TITLE] = '\0';
			m_nCartType[i] = buf[CART_TYPE_OFST];
			m_nSaveSize[i] = GetRamSize(buf[RAM_SIZE_OFST]);
			m_list_rom_ctrl.InsertItem(i, m_szGameTitle[i], 1);
			m_list_rom_ctrl.SetItemText(i, 1, GetCartTypeName(m_nCartType[i]));
			m_list_rom_ctrl.SetItemText(i, 2, GetStrSize(m_nGameSize[i]));
			m_list_rom_ctrl.SetItemText(i, 3, GetStrSize(m_nSaveSize[i]));
			m_list_rom_ctrl.SetItemData(i, (DWORD_PTR)m_szRomFName[i]);
			i++;
		}
		if ( i < MAX_MULTI_GAMES )
		{
			m_nCartType[i] = 0;
			m_nGameSize[i] = 0;
			m_nSaveSize[i] = 0;
		}
	}
}

void CFlashManGBxDlg::OnBnClickedBtnLdel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	int nItem = -1;
	while ( (nItem = m_list_rom_ctrl.GetNextItem(nItem, LVNI_SELECTED)) != -1 )
		if ( m_list_rom_ctrl.GetItemData(nItem) != NULL )
		{
			ChkReservedSize(m_nGameSize[nItem], TRUE);
			for ( int i = nItem; i < min(MAX_MULTI_GAMES - 1, m_list_rom_ctrl.GetItemCount() - 1); i++ )
			{
				m_nCartType[i] = m_nCartType[i+1];
				m_nGameSize[i] = m_nGameSize[i+1];
				m_nSaveSize[i] = m_nSaveSize[i+1];
				_tcsncpy(m_szRomFName[i], m_szRomFName[i+1], MAX_PATH);
			}
			m_nCartType[i] = 0;
			m_nGameSize[i] = 0;
			m_nSaveSize[i] = 0;
			::ZeroMemory(m_szRomFName[i], sizeof(m_szRomFName[0]));
			m_list_rom_ctrl.DeleteItem(nItem);
			--nItem;
		}
}

void CFlashManGBxDlg::OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if ( pNMUpDown->iDelta > 0 )
	{
		// {^
		int nItems = min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()) - 1;
		for ( int i = nItems; i >= 0; i-- )
			if ( m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED) && m_list_rom_ctrl.GetItemData(i) )
			{
				if ( i == nItems ) break;
				CString str = m_szRomFName[i];
				_tcsncpy(m_szRomFName[i], m_szRomFName[i+1], MAX_PATH);
				_tcsncpy(m_szRomFName[i+1], str, MAX_PATH);
				u32 temp = m_nCartType[i];
				m_nCartType[i] = m_nCartType[i+1];
				m_nCartType[i+1] = temp;
				temp = m_nGameSize[i];
				m_nGameSize[i] = m_nGameSize[i+1];
				m_nGameSize[i+1] = temp;
				temp = m_nSaveSize[i];
				m_nSaveSize[i] = m_nSaveSize[i+1];
				m_nSaveSize[i+1] = temp;
				for ( int j = 0; j < 4; j++ )
				{
					str = m_list_rom_ctrl.GetItemText(i, j);
					m_list_rom_ctrl.SetItemText(i, j, m_list_rom_ctrl.GetItemText(i+1, j));
					m_list_rom_ctrl.SetItemText(i+1, j, str);
				}
				UINT state = m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED | LVIS_FOCUSED);
				m_list_rom_ctrl.SetItemState(i,
					m_list_rom_ctrl.GetItemState(i+1, LVIS_SELECTED | LVIS_FOCUSED),
					LVIS_SELECTED | LVIS_FOCUSED);
				m_list_rom_ctrl.SetItemState(i+1, state, LVIS_SELECTED | LVIS_FOCUSED);
			}
	}
	else if ( pNMUpDown->iDelta < 0 )
	{
		// {^
		for ( int i = 0; i < min(MAX_MULTI_GAMES, m_list_rom_ctrl.GetItemCount()); i++ )
			if ( m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED) && m_list_rom_ctrl.GetItemData(i) )
			{
				if ( i == 0 || m_list_rom_ctrl.GetItemData(i-1) == 0 ) break;
				CString str = m_szRomFName[i-1];
				_tcsncpy(m_szRomFName[i-1], m_szRomFName[i], MAX_PATH);
				_tcsncpy(m_szRomFName[i], str, MAX_PATH);
				u32 temp = m_nCartType[i-1];
				m_nCartType[i-1] = m_nCartType[i];
				m_nCartType[i] = temp;
				temp = m_nGameSize[i-1];
				m_nGameSize[i-1] = m_nGameSize[i];
				m_nGameSize[i] = temp;
				temp = m_nSaveSize[i-1];
				m_nSaveSize[i-1] = m_nSaveSize[i];
				m_nSaveSize[i] = temp;
				for ( int j = 0; j < 4; j++ )
				{
					str = m_list_rom_ctrl.GetItemText(i-1, j);
					m_list_rom_ctrl.SetItemText(i-1, j, m_list_rom_ctrl.GetItemText(i, j));
					m_list_rom_ctrl.SetItemText(i, j, str);
				}
				UINT state = m_list_rom_ctrl.GetItemState(i-1, LVIS_SELECTED | LVIS_FOCUSED);
				m_list_rom_ctrl.SetItemState(i-1,
					m_list_rom_ctrl.GetItemState(i, LVIS_SELECTED | LVIS_FOCUSED),
					LVIS_SELECTED | LVIS_FOCUSED);
				m_list_rom_ctrl.SetItemState(i, state, LVIS_SELECTED | LVIS_FOCUSED);
			}
	}
	*pResult = 0;
}

void CFlashManGBxDlg::OnDropFiles(HDROP hDropInfo)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if ( m_pThread )
	{
		CDialog::OnDropFiles(hDropInfo);
		return;
	}
	CPoint pt;
	CRect rect;
	::GetCursorPos(&pt);
	ScreenToClient(&pt);
	GetWindowRect(&rect);
	if ( pt.x > rect.Width() / 2 )
	{
		if ( m_nRamSize == 0 )
		{
			AfxMessageBox(MULTI_LANG(
				"Z[u[܂̂ŏނƂł܂B",
				"Can NOT write save data because of NO save memory."));
			CDialog::OnDropFiles(hDropInfo);
			return;
		}
		::DragQueryFile(hDropInfo, 0, m_strFileName.GetBuffer(MAX_PATH), MAX_PATH);
		m_strFileName.ReleaseBuffer();
		CString str;
		str.Format(MULTI_LANG(
			"t@C`%s'Z[uf[^(RAM)ɏ݂܂B",
			"Write file`%s' to save data(RAM)."), m_strFileName);
		if ( AfxMessageBox(str, MB_ICONINFORMATION | MB_OKCANCEL) == IDOK )
		{
			BtnEnable(FALSE);
			m_bAbort = FALSE;
			m_bStop = FALSE;
			if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
			m_pThread = AfxBeginThread(CFlashManGBxDlg::WriteRam, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
		}
	}
	else
	{
		CFile f;
		u8 buf[MAX_ROM_HEADER];
		u32 i = m_list_rom_ctrl.GetItemCount();
		u32 nFiles = ::DragQueryFile(hDropInfo, -1, NULL, 0);
		for ( u32 k = 0; i < MAX_MULTI_GAMES && k < nFiles; k++ )
		{
			::DragQueryFile(hDropInfo, k, m_szRomFName[i], MAX_PATH);
			if ( !f.Open(m_szRomFName[i], CFile::modeRead) ) continue;
			if ( f.Seek(ROM_HEADER_OFST, CFile::begin) != ROM_HEADER_OFST ) continue;
			if ( f.Read(buf, MAX_ROM_HEADER) != MAX_ROM_HEADER ) continue;
			f.Close();
			if ( memcmp(buf+CART_LOGO_OFST, m_cartLogo, sizeof(m_cartLogo)) != 0 ) continue;
			m_nGameSize[i] = GetRomSize(buf[ROM_SIZE_OFST]);
			if ( !ChkReservedSize(m_nGameSize[i]) ) break;
			for ( u32 j = 0; j < MAX_GAME_TITLE; j++ )
				m_szGameTitle[i][j] = (TCHAR)buf[CART_LOGO_OFST+sizeof(m_cartLogo)+j];
			m_szGameTitle[i][MAX_GAME_TITLE] = '\0';
			m_nCartType[i] = buf[CART_TYPE_OFST];
			m_nSaveSize[i] = GetRamSize(buf[RAM_SIZE_OFST]);
			m_list_rom_ctrl.InsertItem(i, m_szGameTitle[i], 1);
			m_list_rom_ctrl.SetItemText(i, 1, GetCartTypeName(m_nCartType[i]));
			m_list_rom_ctrl.SetItemText(i, 2, GetStrSize(m_nGameSize[i]));
			m_list_rom_ctrl.SetItemText(i, 3, GetStrSize(m_nSaveSize[i]));
			m_list_rom_ctrl.SetItemData(i, (DWORD_PTR)m_szRomFName[i]);
			i++;
		}
		if ( i < MAX_MULTI_GAMES )
		{
			m_nCartType[i] = 0;
			m_nGameSize[i] = 0;
			m_nSaveSize[i] = 0;
		}
	}
	::DragFinish(hDropInfo);

	//CDialog::OnDropFiles(hDropInfo);
}

BOOL CFlashManGBxDlg::ChkReservedSize(u32 nRomSize, BOOL bDel)
{
	if ( !bDel && m_nRomSize < m_nReservedSize + nRomSize )
	{
		AfxMessageBox(MULTI_LANG(
			"\񂷂t@C̍v̑傫tbVJZbg̗eʂzĂ܂B",
			"Total size of reserving files is LARGER than whole capacity of Flash Cartridge."));
		return FALSE;
	}
	if ( !bDel ) m_nReservedSize += nRomSize;
	else m_nReservedSize -= nRomSize;
	if ( m_nRomUnuSize < m_nReservedSize )
	{
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(FALSE);
		SetDlgItemText(IDC_STC_ROMFREE,
			GetStrSize(0, TRUE) + _T("/") +
			GetStrSize((u8)m_nCartType ? m_nRomSize - m_nReservedSize : 0));
	}
	else
	{
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow();
		SetDlgItemText(IDC_STC_ROMFREE,
			GetStrSize(m_nRomUnuSize - m_nReservedSize, TRUE) + _T("/") +
			GetStrSize((u8)m_nCartType ? m_nRomSize - m_nReservedSize : 0));
	}
	return TRUE;
}

void CFlashManGBxDlg::OnBnClickedOk()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	SetCmdToULx(TARGET_END, 0, 0, 0);
	AfxMessageBox(MULTI_LANG(
		"uGB Xchangerv̓d؂AJZbgĂB\n"
		"܂ĂѓdAuOKv{^ĂB",
		"`Turn OFF `GB Xchanger' first and change a cartridge.\n"
		"When it has been done, turn ON it again and click [OK] button."),
		MB_ICONINFORMATION);
	BtnEnable(FALSE);
	m_bAbort = FALSE;
	m_bStop = TRUE;
	m_nTimer = NULL;
	m_pThread = AfxBeginThread(CFlashManGBxDlg::InitULx, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
//	OnOK();
}
