// FlashManGBx.h : PROJECT_NAME AvP[ṼC wb_[ t@CłB
//

#pragma once

#define ULXFM_LEN	(8*1024)
#define ULXFM_NAME	"gbx_boot.bix"

#define WM_THREADFINISHED	WM_USER + 5	// [U[`bZ[W

#define ROM_HEADER_OFST	0x100
#define CART_LOGO_OFST	0x4
#define CART_TYPE_OFST	0x47
#define ROM_SIZE_OFST	0x48
#define RAM_SIZE_OFST	0x49
#define BLOCK_SIZE		0x00008000
#define RAM_BANK_SIZE	0x00002000	// 8KB
#define MAX_ROM_HEADER	0x50
#define MAX_MULTI_GAMES	100
#define MAX_GAME_TITLE	16

#define BULK_IN_PIPE	2
#define BULK_OUT_PIPE	3

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{

#include "type.h"
#include "ezusbsys.h"
#include "gbx_boot\target_cmd.h"

#ifndef LANG_ENG
	#define MULTI_LANG(jpn, eng)	_T(jpn)
#else
	#define MULTI_LANG(jpn, eng)	_T(eng)
#endif


// CFlashManGBxApp:
// ̃NX̎ɂẮAFlashManGBx.cpp QƂĂB
//

class CFlashManGBxApp : public CWinApp
{
public:
	CFlashManGBxApp();

// I[o[Ch
	public:
	virtual BOOL InitInstance();

// 

	DECLARE_MESSAGE_MAP()
};

extern CFlashManGBxApp theApp;
