// FlashManGBxDlg.h : wb_[ t@C
//

#pragma once
#include "afxcmn.h"


// CFlashManGBxDlg _CAO
class CFlashManGBxDlg : public CDialog
{
// RXgNV
public:
	CFlashManGBxDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_FLASHMANGBX_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnThreadFinished(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	DECLARE_MESSAGE_MAP()

private:
	BOOL DownloadULxFirm();
	void AbortULx();
	CString GetStrSize(u32 m, BOOL bShort = FALSE);
	void BtnEnable(BOOL bEnable = TRUE);
	void ChkRamBtn();
	void RefreshCartInfo();
	const TCHAR* GetCartTypeName(u8 d);
	BOOL ChkReservedSize(u32 nRomSize, BOOL bDel = FALSE);
	static BOOL SetCmdToULx(u8 nCmd, u32 p1, u32 p2, u32 p3);
	static BOOL WriteULx(u8 *pData, u32 len);
	static BOOL ReadULx(u8 *pData, u32 len);
	static UINT InitULx(LPVOID pParam);
	static void GetCartInfoULx();
	static u32 GetTailOfs();
	static u32 GetRomSize(u8 d);
	static u32 GetRamSize(u8 d);
	static UINT ReadRom(LPVOID pParam);
	static UINT EraseRom(LPVOID pParam);
	static UINT WritePreBoot(LPVOID pParam);
	static UINT WriteAppendRom(LPVOID pParam);
	static UINT ReadRam(LPVOID pParam);
	static UINT WriteRam(LPVOID pParam);
	CString m_strDevName;
	HICON m_hIconAdd;
	HICON m_hIconDel;
	CListCtrl m_list_rom_ctrl;
	CImageList m_imageList;
	CToolTipCtrl m_toolTipCtrl;
	CWinThread* m_pThread;
	UINT_PTR m_nTimer;
	u32 m_nReservedSize;
	static const UINT m_iToolTipItems[];
	static HANDLE m_hULx;
	static const u8 m_ulxfm[];
	static u32 m_nRomType;
	static u32 m_nRomSize;
	static u32 m_nRomBlkSize;
	static u32 m_nRomUnuSize;
	static u32 m_nRamSize;
	static u32 m_nRamOffset;
	static BOOL m_bAbort;
	static BOOL m_bStop;
	static const u8 m_cartLogo[];
	static TCHAR m_szGameTitle[MAX_MULTI_GAMES][MAX_GAME_TITLE + 1];
	static TCHAR m_szRomFName[MAX_MULTI_GAMES][MAX_PATH];
	static u32 m_nCartType[MAX_MULTI_GAMES];
	static u32 m_nGameSize[MAX_MULTI_GAMES];
	static u32 m_nSaveSize[MAX_MULTI_GAMES];
	static int m_nProgress;
	static const TCHAR m_szPrgFilter[];
	static const TCHAR m_szSavFilter[];
	static CString m_strFileName;
	static u32 m_nEraseOfs;
	static u8 m_buf[];
public:
	afx_msg void OnBnClickedBtnStop();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedBtnAread();
	afx_msg void OnBnClickedBtnErase();
	afx_msg void OnBnClickedBtnPwrite();
	afx_msg void OnBnClickedBtnAwrite();
	afx_msg void OnBnClickedBtnSread();
	afx_msg void OnBnClickedBtnSwrite();
	afx_msg void OnLvnItemchangedListRom(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnLadd();
	afx_msg void OnBnClickedBtnLdel();
	afx_msg void OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnBnClickedOk();
};
